

 ** OHYMOS-3 README **

                        Organizations and persons who developed OHyMoS
                        and cooperated the development

                        Organizations:
                        Takasao Lab., Kyoto University
                        River Disaster Prevention Research Section,
                        DPRI, Kyoto University
                        Flood Disaster Research Section, Fluvial and
                        Marine Disaster Research Division, DPRI, Kyoto
                        Universirty
                        Hydrology and Water Resources Engineering
                        Lab., Department of Civil Eng. Systems,
                        Graduate School of Engineering, Kyoto
                        University
                        Laboratory of Environmental Resources Circulation,
                        Graduate School of Global Environmental Studies,
                        Kyoto University
                        Hydrology and Water Resources Engineering
                        Lab., Department of Urban and Environmental 
                        Engineering, Graduate School of Engineering, 
                        Kyoto University

OHyMoS Ver. 3.5.2

OHyMoS-3 is an Object-oriented Hydrologic Modeling System originaly
developed by Takasao Laboratory in Kyoto Univerisity and now developed
and maintained by Hydrology and Water Resources Engineering Lab.,
Department of Urban and Environmental Engineering, Graduate School of
Engineering, Kyoto University.

The use and developlent of OHyMoS is not restricted to only these
organizations and persons. If your organization and/or you can help
development of OHyMoS, please let Shiiba know it.

OHyMoS-3 is a system for building runoff system models following
the "object-oriented modeling method", being realized using an
object-oriented computer lanaguage C++.

The "object-orinted modeling method" is a method that we extract the
basic and common structures in hydrologic models, and build individual
hydrologic models by inheriting from the extracted models.

At present, individual hydrologic models also should be described by
using the language C++.

We do not abandon our copyright over all documents and programs
contained in "ohymos-3.5.2.tgz," if those programs have been developed
by us.  If you distribute some pragrams contained in ohymos-3.5.2.tgz,
you should distribute all files contained in ohymos-3.5.2.tgz.

ohymos-3.5.2.tgz contains some programs developed by others, such as
src2tex.  Those programs conatain also documents. Please follow those
documents about the redistribution of those programus.

Of cource, You can create new models by inheritance from the classes
offered in ohymos-3.5.2.tgz, and we are pleased if you make open the
outcome, because our modeling system will become richer owing to it.

However, don't redistiribute the revised version in which the core,
common part of the system is different from ohymos-3.5.2.tgz, because if
various versions exist, we may not exchange element models.

We welcome your constructive opinions about the core, common part of the
system, and we would like to make better verisions by considering those
opinions. At present, mainly Shiiba maintaines the OHyMoS, please
arrange so that your opinion reaches to Shiiba.

You can change personally the core part for your own puropose if you do
not distribute the revised version.

How to install
==============

Execute

% tar zxvf ohymos-3.5.2.tgz

Makefile to create the OHyMoS library is contained in the package.

If you execute,

% make all

then, you will get "libohymos.a" and a test program "test_e."

If you exucute

% make lib

then "libohymos.a" will be created, but "test_e" will not be created.

For installing header files and library to your favorite directory,
please change the macro definitions in the makefile, and then execute

% make install

The macros to be changed are as the following:

prefixdir

     Usually, your own home directory. This will be used for dermination
     of macros USRINCLUDEDIR, USRSOURCEDIR, USRLIBDIR. If you define
     USRINCLUDEDIR, USRSOURCEDIR, LIBDIR without $(prefixdir), then
     the definition of prefixdir is not necessary.

USRINCLUDEDIR

    The directory under which the header files for using libohymos.a are
    placed.

USRSOURCEDIR

    The directory under which the source files for creating
    libohymos.a are stored.

USRLIBDIR

    The directory under which you place libohymos.a.


Environment variables
=====================

OHYMOSSDIR

    In OHyMoS, error messages are not stored in execution files, but the
    program will search error messages written in the source files and
    print out them. (See Eprint and Wprint in common.h and common.cc)

    In environment variable OHYMOSSDIR, please list the names of the
    directories under which the source files are placed, dividing by ;
    (semicolon) between directories.

    The functions Eprint and Wprint which print error messages are
    defined in common.cc.

Systems for using C++
=====================

Templates and class definition within a class are used in OHyMoS.

GNU G++ 2.5.8 ore later are copyleft softwares which have these
features.

OHyMoS-3 is made using GNU g++ 2.7.2 and the makefiles contained in the
package are prepared under the assumption that the users use GNU g++
2.7.2.  If you use other versions of GNU g++ or other compilers, please
note about compiler options relating templates.

documents
=========

README          This document
hymoshist.txt   history of updates
inputfile.txt   how to prepare parameter files and initial data files
datapack.txt    explanation of datapacks
element.txt     how to make element models
total.txt       how to make a total model
iterate.txt     how iteration calculations among elements are done
question.txt

references
==========

@InProceedings{Suzuki:92,
  author =  " ϯܪ ϡ  Ω ",
  title =   "ήήХߥ졼ǥΥƥಽ˴ؤ
         븦",
  booktitle =   "ڳز 47 ǯؽѹֱֱ鳵׽裲",
  year =    "1992",
  pages =   "474--475",
  organization =    "ڳز",
  yomi =    "{\noop{}} \noop{}"
}

@InProceedings{Suzuki:93,
  author =  " ϯܪ ϡ   ",
  title =   "ʬ۷ήХǥˤήǥǥ饤֥깽ۤ
         ؤ븦",
  booktitle =   "ڳز 48 ǯؽѹֱֱ鳵׽裲",
  year =    "1993",
  pages =   "218--219",
  organization =    "ڳز",
  yomi =    "{\noop{}} \noop{}"
}

@Article{Takasao93d,
  author =  "ܪ ϡ   ϯ",
  title =   "ήХߥ졼ǥ빽οȤ",
  journal =     "幩ʸ",
  year =    1993,
  volume =  "37",
  pages =   "805--808",
  yomi =    "{\noop{}}ܪ \noop{}"
}

@InProceedings{Takasao:93d,
  author =  "ܪ ϡ   ϯ ",
  title =   "ʬ۷ήХǥˤήǥǥ饤֥깽ۤ
         ؤ븦",
  booktitle =   "ʸ񸻳ز 1993 ǯȯɽ׻ݽ",
  year =    "1993",
  pages =   "68--69",
  location =    "",
  organization =    "ʸ񸻳ز",
  yomi =    "{\noop{}}ܪ \noop{}"
}

@InProceedings{Takasao:94,
  author =  "ܪ ϡ   ϯ ",
  title =   "ήзϤι¤Ūǥ벽ˤĤ",
  booktitle =   "ʸ񸻳ز 1994 ǯȯɽ׻ݽ",
  year =    "1994",
  pages =   "186--187",
  location =    "̸",
  organization =    "ʸ񸻳ز",
  yomi =    "{\noop{}}ܪ \noop{}"
}

@InProceedings{Takasao:94d,
  author =  "ܪ ϡ  Ω ͡ ϯ
          ",
  title =   "ήзϤι¤Ūǥ벽ˡ {D}ynamic {W}ave ǥ",
  booktitle =   "ڳز 49 ǯؽѹֱֱ鳵׽裲",
  year =    "1994",
  pages =   "102--103",
  organization =    "ڳز",
  yomi =    "{\noop{}}ܪ \noop{}"
}

@Article{Takasao95,
  author =  "ܪ ϡ  ",
  title =   "¤Ūǥ󥰥ƥѤήХߥ졼",
  journal =     "幩ʸ",
  year =    "1995",
  yomi =    "{\noop{}}ܪ \noop{}"
}

Copyright(C) 2007 Kyoto University, All Rights Reserved.
$Revision: 1.8 $
