/*;  datapack.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl datapack.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:40:52 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/datapack.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  ܷǡѥåǥκ

/* <japanese>

ưŪ˾֤ʸߥ졼ˤƤ, Ǥʬ, 
ηϤδ֤ǼǡϾʤȤⲿ餫ΥǡͤȥǡϿ
Ф˵ƤΤȹͤޤ ǡϿȤ, ߥ졼
ΤʤǥƥưŪѲϿ뤿ꤷ֤ˤ, 
ΤȤǤ

ǡǡϿ˴ؤ˴ؤ귿줿򤢤餫
Ƥˡܷǡѥåǥ \verb|Data_pack| 뤳Ȥˤޤ


ܷǡѥåǥ \verb|Data_pack| Ǥ,
\begin{verbatim}
		ǡϿ        : data_time
\end{verbatim}

򵭲,
\begin{verbatim}
		ǡϿ굡ǽ
		ǡϿμǽ
\end{verbatim}

ޤ. 	ƥǥ뤬ǡΥǥ, 饹
\verb|Data_pack| ѾƺƲ. ѾƺǥǤϡ
ǡ֤ͤؿ Value Ƥ

<japanese> */

//;  datapack.h              ܷǡѥåǥκ

#if !defined(datapack_h)
#define datapack_h

#include <stdio.h>
#include <time.h>
	/* <japanese>
	      time.h  time_t   tm Ƥ.
		time_t        : "" ɽ (long Ƥ)
		tm            : "ǯ, , , , ʬ, " 򵭲빽¤

	time_t ν񼰽Ϥˤ, %ld ѤƲ.

	time_t , tm ѴˤϲδؿѤǤޤ.
	, 0 sec (time_t ) = G.M.T. 1970.01.01. 00:00:00 (tm ) Ȥ
	Ѵޤ.
		localtime     : time_t  ==> tm  (UNIX, ANSI)
		timelocal     : tm  ==> time_t  (UNIX)
		mktime        : tm  ==> time_t  (ANSI)

    </japanese>
	*/


/*----------------------------------------------------------------------
CLASS

    Data_pack

    abstract class for treating a pair of data time and data value which
    we call datapack

KEYWORDS

    datapack, data time, data value

DESCRIPTION

    In hydrologic simulations in which the states are updated
    dynamically, the data which are sent and received by elements,
    subsytems, and total sytem of the hydrologic system are pairs of
    data value(s) and a "data time."  Here, "data time" means the time
    to which the data are related.

    For example, suppose we have the value of discharge Q at time t at
    some stream point. Then, we call the value of discharge Q "data
    value" and time t "data time."

    We call a pair of data time and data value "datapack," and we
    prepare class Data_pack, which is an abstract class used as a base
    class from which various datapack classes are derived.

    <dl><dd>
             "datapack" = "data time" + "data value"
    </dl>

    Because there are various data types for data value, there could be
    various datapack classes.

    Class Data_pack is a base class from which various datapack classes
    are derived.

    keywords: datapack, data time, data value

----------------------------------------------------------------------*/

class Data_pack {
	/* <japanese>
	 Data_pack       ܷǡѥåǥΥ饹

	饹 Data_pack Ǥ,
		ǡϿ        : data_time
	򵭲,
		ǡϿ굡ǽ
		ǡϿμǽ
	ޤ.

	ƥǥ뤬ǡΥǥ, 饹 Data_pack Ѿƺ
	Ʋ.
    </japanese>
	*/

//      0.      ǡ.
protected:
  //////////////////////////////////////////////////////////////////////
  // the unix time when the data was recorded.
  time_t  data_time;

//      1.      ǡϿ굡ǽ, ǡϿ, ǡμǽ.
public:

  //////////////////////////////////////////////////////////////////////
  // Returns the data time
  time_t Data_time(void) {
    return data_time;
  }

  //////////////////////////////////////////////////////////////////////
  // Set the data time
  void Set_data_time(time_t d_time) { data_time = d_time; }
		/* <japanese>
		 Data_pack::Data_time(void) (inline)             data_time ֤
		 Data_pack::Set_data_time(time_t) (inline)       data_time 

		ARGUMENT:
			d_time        ǡϿ (sec).
        </japanese>
		*/

//		2.		ǡѴǽ
public:
  //////////////////////////////////////////////////////////////////////
  // Declares the function Dpack2file as pure virtual. Dpack2file prints
  // the datapack into a file in the data format for internal work.
  virtual void Dpack2file(FILE* fp) = 0;
		/* <japanese>
		  Data_pack::Dpack2file(FILE*fp) = NULL

		ǡѥåѥեޥåȤǥե˽񤭽Фޤ
        </japanese>
		*/

  //////////////////////////////////////////////////////////////////////
  // Declares the function Dpack2ofile as pure virtual. Dpack2ofile
  // prints the datapack into a file in the simple data format.
  virtual void Dpack2ofile(FILE* fp) = 0;
		/* <japanese>
		  Data_pack::Dpack2file(FILE*fp) = NULL

		ǡѥåʰץեޥåȤǥե˽񤭽Фޤ
        </japanese>
		*/

  //////////////////////////////////////////////////////////////////////
  // Declare the function Dstr2dpack as pure virtual.  Dstr2dpack reads
  // the datapack datum from the data string 'dstr'.
  virtual void Dstr2dpack(char*& dstr) = 0;
		/* <japanese>
		  Data_pack::Str2dpack(char*& dstr) = NULL

		ʸ󤫤ǡɤߤȤä, ǡѥåͤꤷޤ

        </japanese>
		*/

//      3.      󥹥ȥ饯, ǥȥ饯.
public:
  //////////////////////////////////////////////////////////////////////
  // Constructor
  Data_pack(void) : data_time(0) {}

  //////////////////////////////////////////////////////////////////////
  // Destructor.  Data_pack is an abstract class, the destructor is
  // declared as virtual.
  virtual ~Data_pack(void) {}
		/* <japanese>
		 Data_pack::Data_pack(void) (inline)             󥹥ȥ饯
		 Data_pack::~Data_pack(void) (inline,virtual)    ǥȥ饯

		Data_pack(void) , data_time  0 ˽ޤ.

		饹 Data_pack ݥ饹ʤΤ, 饹η˱ǥ
		饯ŬѤ褦, ~Data_pack ۥǥȥ饯Ȥޤ.
        </japanese>
		*/

};


//      ؿ Clear_dp .

  //////////////////////////////////////////////////////////////////////
  // Definition of function Clf_dp which is used for deleting list-type
  // object which stores datapack.  This function is used in send.cc
inline void Clf_dp(void* dp) { delete ((Data_pack*) dp); }
	/* <japanese>
	 Clf_dp(void*) (inline)  ǡѥåõѴؿ

	δؿ Clear_function  * (list.h / Clear_function ) , ǡ
	ѥåϿ List ֥Ȥõ, Ʊ˼Ͽǡ
	ѥåõ뤿δؿǤ.

	ҡΰ˵줿 Data_pack 饹Υ֥Ȥꥹ
	 List ˼Ͽ, ɬפ˱ List Υ󥹥ȥ饯ΰ
	Ʋ. (list.h / List::List )

	ARGUMENT:
		dp    Data_pack ֥ȤؤΥݥ󥿤, void* ˥㥹
				Ȥ줿.
    </japanese>
	*/

#endif  // ! datapack_h

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.2 $
Revision: 1.7 ѹ
Data_pack::Value 貾۴ؿȤΤȤߤޤ

Revision: 1.6 ѹ
Data_pack::Value 貾۴ؿȤޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
