/* object.cc 饹 Object μ
{\documentstyle{jsrc2latex}\rhead{\sl object.cc\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:06:46 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"     // ץˤ붦

#include "object.h"     // 饹 Object 

static void reverse(
  char *s
)
{
  int c;
  char *t;
  for (t = s + (strlen(s)-1); s < t; s++, t--) {
    c = *s;
    *s = *t;
    *t = c;
  }
}

static void itoa(
  int n,
  char *s
  )
{
  int sign;
  char *t = s;
  if ((sign = n) < 0) {
    n = -n;
  }
  do {
    *s++ = n % 10 + '0';
  } while ((n /= 10) > 0);
  if (sign < 0) {
    *s++ = '-';
  }
  *s = '\0';
  reverse(t);
}

//  饹 Object Υдؿ.

Boolean Object::Set_owner(void* o)
{   //    Object::Set_owner(void*) (define)

    if (o == NULL)  // invalid argument
        { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
            // Object::Set_owner(void*)
            // Invalid argument. "o" is NULL.

    if (owner != NULL && owner != o) {    // doubly setted
      // originally, the case where owmer is equal to o was treated as
      // error.  Now the case is accepted.
      // 2000-08-25. cbar
        Eprint(__FILE__, __LINE__);
            // Object::Set_owner(void*)
            // "owner" has already been set. Doubly setting?
        ((Object*) owner)->Oprint("    first : ");
        ((Object*) o)->Oprint("    next  : ");
        Cprint("    "); return NO;
    }

    owner = o; return YES;
}


void Object::Cprint(FILE* fp_out, char* head)
{   //    Object::Cprint(FILE*,char*) (define)

    fprintf(fp_out,
        "%s%s %s %d\n",
        head, class_name, object_name, object_number);
}


void Object::Oprint(FILE* fp, char* head)
{   //    Object::Oprint(FILE*,char*) (define)

    Cprint(fp, head);

    static int k[2]; k[0] = 0;
        // owner ɽ. ­¹ԤǤ褦 static Ȥ.
    for (void* buf = owner; buf != NULL; buf = ((Object*) buf)->Owner()) {
        // ֥Ȥ owner ꤵƤ¤Ϥ³.
        fprintf(fp, "%s    owner ", head);
        for (k[1] = (++k[0]); k[1] > 0; k[1]--) fprintf(fp, ">");
            // '>'  k[0] ĽϤ.
        ((Object*) buf)->Cprint(fp, " ");
    }
}


Boolean Object::Init(char* o_name, int o_num)
{   //    Object::Init(char*,int) (define)

    if (o_name == NULL)     // .
        { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
            // Object::Init(char*,int)
            // Invalid argument "o_name".

    if (object_name != NULL) {
        Eprint(__FILE__, __LINE__);
            // Object::Init(char*,int)
            // Doubly setting "object_name".
        fprintf(stderr,
            "\to_name(arg) = \"%s\", o_num(arg) = %d", o_name, o_num);
        Oprint(); return NO;
    }

    if ((object_name = new char[strlen(o_name) + 1]) == NULL) {
        Eprint_memory(__FILE__, __LINE__, "char",
                      ((int) (strlen(o_name) + 1)));
            // Object::Init(char*,int)
            // For "object_name".
        exit(5);
    }

    strcpy(object_name, o_name); object_number = o_num; return YES;
}


Object::Object(char* o_name, int o_num)
    :   class_name("Object"), object_name(NULL), object_number(0),
        owner(NULL)
{   //    Object::Object(char*,int) (define)

    Init(o_name, o_num);
}


Object::Object(void)
    :   class_name("Object"), object_name(NULL), object_number(0),
        owner(NULL)
{   //    Object::Object(void) (define)
}


Object::~Object(void)
{   //    Object::~Object(void) (define)

    delete [] object_name;
}

void
Object::Absname(   //; Set the name which specifies the object
		   //; uniquely
  char* absname    //; the string to store the name
)
{
  /*
     object Ūɽ֤̾ޤ
     owner ΰŪ̾ˡ"/" ³object_name"__",
     object_number ³ޤ
     owner  NULL ξϡowner ΰŪ̾ϡ"" Ȥޤ
     :  㤨Сowner ΰŪ̾ /tatal_system__0 Ǥꡢ
     object_name  elm_tobject_number  0 ʤ顢
     /total_system__0/elm_t__0  absname ˤʤޤabsname Ǽ뤿
     εϡƽ¦ǳݤƤɬפޤ
  */

  if (owner == NULL) {
    *absname = '\0';
  }
  else {
    ((Object*)owner)->Absname(absname);
  }
  strcat(absname, "/");
  strcat(absname, object_name);
  strcat(absname, "__");
  char s[8];
  itoa(object_number, s);
  strcat(absname, s);
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
\end{verbatim}\end{comment}
} */
