/* relay.cc {\documentstyle{jsrc2latex}\rhead{\sl relay.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 Relay_port μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:08:39 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "common.h"		// ץˤ붦
#include "object.h"		// 饹 Object 
#include "port.h"		// 饹 Port 
#include "sender.h"		// 饹 Sender_port 

#include "relay.h"		// 饹 Relay_port 


//	饹 Relay_port Υдؿ.

Boolean Relay_port::Set_sender(void* s)
{	//		Relay_port::Set_sender(void*) (define)

	if (s == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Relay_port::Set_sender(void*)
		// Cannot set "sender".
		// "s" (arg) is NULL.

	if (sender != NULL) {
		// sender Ѥ. (ꡩ)
		Eprint(__FILE__, __LINE__);
			// Relay_port::Set_sender(void*)
			// "sender" has already been set. Doubly setting?
		((Object*) sender)->Cprint("    connected to  : ");
		((Object*) s)->Cprint("    connecting to : ");
			// s  Object* ѿǤʤ, ۾ư.
		Oprint(); return NO;
	}

	char* s_type = ((Port*) s)->Data_pack_type();
	char* r_type = Data_pack_type();
		// üҤμǡѥå s ǡѥå.
		// s  Port* Ǥʤ, ۾ư.
	if (strcmp(s_type, r_type) != 0) {
		// üҤ s Ȥǥǡѥåۤʤ.
		Eprint(__FILE__, __LINE__);
			// Relay_port::Set_sender(void*)
			// 'data_pack_type' of this port and "s" (arg) are defferent.
		((Object*) s)->Oprint("    s > "); Oprint(); return NO;
	}

	sender = s; return YES;
}


void Relay_port::Print_connection(FILE* fp_out, char* head)
{	//		Relay_port::Print_connection(FILE*,char*) (define)

	Oprint(fp_out, head);

	if (sender == NULL)
		fprintf(fp_out, "%s\tNot connected to sender.\n", head);

	char* title = "Connected > ";
	int len = strlen(title) + 1;
	len += (head != NULL) ? strlen(head) : 0;

	char* tmp = new char[len];
	if (tmp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, YES); Oprint(); exit(5); }
			// Relay_port::Print_connection(FILE*,char*)
	if (head != NULL) strcpy(tmp, head);
	else strcpy(tmp, "");
	strcat(tmp, title);

	((Object*) sender)->Oprint(fp_out, tmp);

	if (number_of_receivers <= 0)
		fprintf(fp_out, "%s\tNot connected to receiver.\n", head);

	for (int k = 0; k < number_of_receivers; k++)
		((Object*) receiver_array[k])->Oprint(fp_out, tmp);

	delete [] tmp;
}


Relay_port::Relay_port(char* p_name, int p_num)
	:	Sender_port(),
		sender(NULL)
{	//		Relay_port::Relay_port(char*,int) (define)

	class_name = "Relay_port";

	Init(p_name, p_num);
}


Relay_port::Relay_port(void)
	:	Sender_port(),
		sender(NULL)
{	//		Relay_port::Relay_port(void) (define)

	class_name = "Relay_port";
}


Relay_port::~Relay_port(void)
{	//		Relay_port::Relay_port(void) (define)
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Revision: 1.1 ѹ
delete ʸ delete [] 

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
