/* send.cc {\documentstyle{jsrc2latex}\rhead{\sl send.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 Send_port μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:08:46 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>		//; time_t , tm 
#include <limits.h>		//; LONG_MIN, LONG_MAX 

#include "common.h"		//; ץˤ붦
#include "list.h"		//; 饹 List 
#include "datapack.h"	//; 饹 Data_pack 
#include "element.h"	//; 饹 Element 

#include "send.h"		//; 饹 Send_port 
#include "data2str.h"

//;	饹 Send_port Υдؿ.

Boolean Send_port::Switch(void)
{	//;		Send_port::Switch(void) (define)

	if (Sender_port::Switch() != YES)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// <Send_port::Switch>

	if ((number_of_data_packs >= 0) || (data_pack_array != NULL))
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Send_port::Switch(void)
			// Already exists "data_pack_array".

	// buffer_list  data_pack ϿѤȤƺ.
	if ((buffer_list = new List(Clf_dp)) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); Oprint(); exit(5); }
			// Send_port::Switch(void)
			// For "buffer_list", to stock 'data_packs'.
	data_pack_array = NULL; number_of_data_packs = 0;
	return YES;
}


void Send_port::Stock(void* d_pack)
{	//;		Send_port::Stock(void*) (define)

	if ((buffer_list->Number() > 0)
		&& (((Data_pack*) d_pack)->Data_time()
			<= ((Data_pack*) buffer_list->Tail())->Data_time())) {
//		Eprint(__FILE__, __LINE__);
//			// Send_port::Stock(void*)
//			// Cannot send data_pack.
//			// Data time descreapancy has occured.
//		time_t buf[2];
//		buf[0] = ((Data_pack*) d_pack)->Data_time();
//		buf[1] = ((Data_pack*) buffer_list->Tail())->Data_time();
//		fprintf(stderr,
//			"    Among %ld (sec) and %ld (sec). ", buf[0], buf[1]);
//		Oprint();
		return;
	}

	buffer_list->Put_tail(d_pack);
}

int Send_port::Number_of_data_packs(void)
{
	return number_of_data_packs;
}

time_t Send_port::Oldest_data_time(void)
{
    if (number_of_data_packs <= 0) return LONG_MAX;

    return ((Data_pack*) data_pack_array[0])->Data_time();
}

time_t Send_port::Newest_data_time(void)
{
        if (number_of_data_packs <= 0) return LONG_MIN;

        return ((Data_pack*) data_pack_array[number_of_data_packs - 1])
                 ->Data_time();
}

Boolean Send_port::Get_data_pack(
			void*& former, time_t data_time, void*& later, char flag)
{	//;		Send_port::Get_data_pack(void*&,time_t,void*&,char) (define)

	if (number_of_data_packs <= 0)	//; ǡѥåϿ 0.
		{ former = later = NULL; return NO; }

	if (((Data_pack*) data_pack_array[number_of_data_packs - 1])
			->Data_time() < data_time) {
		//; data_time ʹߤΥǡѥåʤ. later Ǥʤ.
		later = NULL;
		if ((flag == 'b') || (flag == 'l')) {
// 			Eprint(__FILE__, __LINE__);
// 				// Send_port::Get_data_pack(void*&,time_t,void*&,char)
// 				// Cannot get 'data_pack'.
// 				// No 'data_pack' stocked after requested time.
// 			time_t temp =
// 	    	((Data_pack*) data_pack_array[number_of_data_packs - 1])
// 		    ->Data_time();
// 			fprintf(stderr,
// 				"        Requested (%ld sec), "
// 				"Last \'data_pack\' (%ld sec) \n",
// 				data_time, temp);
// 			Oprint();
			former = NULL;
			return NO;
		}
		former = data_pack_array[number_of_data_packs - 1];
		return YES;
	}
	else if (((Data_pack*) data_pack_array[number_of_data_packs - 1])
				->Data_time() == data_time) {
		former = later = data_pack_array[number_of_data_packs - 1];
		return YES;
	}

	for (int k = number_of_data_packs - 2; k >= 0; k--)
		if (((Data_pack*) data_pack_array[k])->Data_time() <= data_time) {
			//; former ȯ.
			former = data_pack_array[k];
			later = (((Data_pack*) former)->Data_time() != data_time) ?
						data_pack_array[k + 1] : former;
			return YES;
		}

	//; data_time Υǡѥåʤ. former Ǥʤ.
	former = NULL;
	if ((flag == 'b') || (flag == 'f')) {
// 		Eprint(__FILE__, __LINE__);
// 			// Send_port::Get_data_pack(void*&,time_t,void*&,char)
// 			// Cannot get 'data_pack'.
// 			// No 'data_pack' stocked before requested time.
// 		time_t temp = ((Data_pack*) later)->Data_time();
// 		fprintf(stderr,
// 			"        Requested (%ld sec), "
// 			"First \'data_pack\' (%ld sec) \n",
// 			data_time, temp);
//		Oprint();
		later = NULL; return NO;
	}
	later = data_pack_array[0];
	return YES;
}

void Send_port::Forget_data_pack_stock(time_t t_from)
{
	if (protect_past_data_flag == YES) return;
	if (number_of_data_packs <= 0) return;

		// number_of_data_packs is initially set to -1.
		// If number_of_data_packs is less than 0, there is no data to
		// be deleted.

	// Delete data before t_from
	int k;
	for (k = number_of_data_packs - 1; k >= 0; k--)
		if (((Data_pack*) data_pack_array[k])->Data_time() <= t_from)
			break;

	if (k <= 0) return;		// No data to be deleted

	while (k > 0)	// Delete first k-1 data_pack
		{ delete ((Data_pack*) (buffer_list->Get_head())); k--; }

	Set_data_pack_array();	// Renew data_pack_array
}


void Send_port::Reduce_data_pack_stock(void)
{	//;		Send_port::Reduce_data_pack_stock(void) (define)

	if (protect_past_data_flag == YES) return;
	if (number_of_data_packs <= 0) return;

		// number_of_data_packs is initially set to -1.
		// If number_of_data_packs is less than 0, there is no data to
		// be deleted.

	// Get time before which stored data are not necessary by asking the
	// receivers
	time_t reserve = Necessary_time_from();

	int k;
	for (k = number_of_data_packs - 1; k >= 0; k--)
		if (((Data_pack*) data_pack_array[k])->Data_time() <= reserve)
			break;

	if (k <= 0) return;		// No data to be deleted

	while (k > 0)	// Delete first k-1 data_pack
		{ delete ((Data_pack*) (buffer_list->Get_head())); k--; }

	Set_data_pack_array();	// Renew data_pack_array
}


void Send_port::Clear_data_pack(void)
{	//;		Send_port::Clear_data_pack(void) (define)

	buffer_list->Clear();	// Delete data_pack list itself also
	delete [] data_pack_array; data_pack_array = NULL;
	number_of_data_packs = -1;
}

void Send_port::Save_send_port_stock(FILE* fp)
{	//;		Send_port::Save_send_port_stock(FILE* fp)

	delete [] data_pack_array;
	buffer_list->Make_array(data_pack_array, number_of_data_packs);
	Reduce_data_pack_stock();

	fprintf(fp, "(%d) # number_of_data_packs\n", number_of_data_packs);
	if (number_of_data_packs <= 0) return;

	for (int k = 0; k < number_of_data_packs; k++) {
		fprintf(fp, "\n");
		((Data_pack*) data_pack_array[k])->Dpack2file(fp);
	}
}

Send_port::Send_port(char* p_name, int p_num)
	:	Sender_port(),
		data_pack_array(NULL), number_of_data_packs(-1),
		protect_past_data_flag(NO)
{	//;		Send_port::Send_port(char*,int) (define)

	class_name = "Send_port";
	comment_string = NULL;
	Init(p_name, p_num);
}


Send_port::Send_port(void)
	:	Sender_port(),
		data_pack_array(NULL), number_of_data_packs(-1),
		protect_past_data_flag(NO)
{	//;		Send_port::Send_port(void) (define)

	class_name = "Send_port";
	comment_string = NULL;
}


Send_port::~Send_port(void)
{	//;		Send_port::~Send_port(void) (define)

	delete [] data_pack_array;
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Alterations from Revision: 1.18
The implementasions of
	virtual time_t Oldest_data_time(void);
	virtual time_t Newest_data_time(void);
    virtual int Number_of_data_packs(void);
were added.

Alterations from Revision: 1.15
Careless mistake

Alterations from Revision: 1.14
New member function Forget_past_data_stock was installed.
Function Reduce_data_pack_stock was revised. They refer
protect_past_data_flag.

Revision: 1.13 ѹ
Get_data_pack_array ǷٹåϤƤʬ򥳥ȥȤ


Revision: 1.12 ѹ
Save_send_port_stock νϤβޤ

Revision: 1.10 ѹ
hymoshist.doc 105 ˵Ҥͤѹˤ, Save_send_port_stock 
ޤ

Revision: 1.8 ѹ
Reduce_data_pack_stock ΰѹ.

Revision: 1.4 ѹ
Boolean Send_port::Get_data_pack(...) ǡꤷʹߤ data_pack
ϿƤʤΥ顼åΥХޤ

Revision: 1.2 ѹ
ǡѥå٤üҤƤʤȤ,
Reduce_data_pack_stock ƤФ줿бޤ

Revision: 1.1 ѹ
Stock λͤѹޤƱޤϸŤΥǡѥåϿ
褦ȤȤ, 顼åϤ, ñ̵뤹ˤޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
