/* sender.cc {\documentstyle{jsrc2latex}\rhead{\sl sender.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 Sender_port μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:08:54 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>		// time_t , tm 
#include <limits.h>		// LONG_MIN, LONG_MAX 

#include "common.h"		// ץˤ붦
#include "list.h"		// 饹 List 
#include "object.h"		// 饹 Object 
#include "port.h"		// 饹 Port 
#include "element.h"	// 饹 Element 

#include "sender.h"		// 饹 Sender_port 

//	饹 Sender_port Υдؿ.

Boolean Sender_port::Register_receiver(void* r)
{	//		Sender_port::Register_receiver(void*) (define)

	if (r == NULL) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sender_port::Register_receiver(void*)
		// Cannot register 'receiver'.
		// "s" (arg) is NULL.

	if (number_of_receivers >= 0) {
		/*
		receiver_array Ѥ. buffer_list  'data_pack' ϿѤž
		Ѥ. ³Բ.
		Sender_port::Switch  Sender_port::Register_receiver ƽλ
		Ѥ.
		*/
		Eprint(__FILE__, __LINE__);
			// Sender_port::Register_receiver(void*)
			// Cannot register 'receiver'.
			// "buffer_list" has already been switched.
			// Use "Sender_port::Switch",
			//     after "Sender_port::Register_receiver".
		((Object*) r)->Oprint(); Oprint(); return NO;
	}

	if (buffer_list == NULL)
		{ Eprint(__FILE__, __LINE__); Oprint(); return NO; }
		// Sender_port::Register_receiver(void*)
		// Cannot register 'receiver'.
		// "buffer_list" (arg) is NULL.

	char* s_type = Data_pack_type();
	char* r_type = ((Port*) r)->Data_pack_type();
		// üҤǡѥå r μǡѥå.
		// r  Port* Ǥʤ, ۾ư.
	if (strcmp(s_type, r_type) != 0) {
		// üҤ r Ȥǥǡѥåۤʤ.
		Eprint(__FILE__, __LINE__);
			// Sender_port::Register_receiver(void*)
			// 'data_pack_type' of this port and "r" (arg) are defferent.
		((Object*) r)->Oprint("    r > "); Oprint(); return NO;
	}

	void* buf; buffer_list->Top();	// buffer_list ν.
	while (buffer_list->Look(buf) == YES)
		if (r == buf)  return YES;		// r ³Ѥ.

	buffer_list->Put_tail(r); return YES;
}


Boolean Sender_port::Switch(void)
{	//		Sender_port::Switch(void) (define)

	if (number_of_receivers >= 0) {		// receiver_array ϺѤ.
		Eprint(__FILE__, __LINE__);
			// Sender_port::Switch(void)
			// Cannot switch "buffer_list".
			// "receiver_array" has already been set.
			// "number_of_receivers" should be less than 0, at this stage.
			// Maybe, this port has doubly swiched ,
			//     or some function has changed the value.
	 	fprintf(stderr,
	 		"    number_of_receivers = %d.\n", number_of_receivers);
	 	Oprint(); return NO;
	}

	// receiver_array κ.
	buffer_list->List_to_array(receiver_array, number_of_receivers);

	delete buffer_list; buffer_list = NULL; return YES;
}


time_t Sender_port::Necessary_time_from(void)
{	//		Sender_port::Necessary_time_from(void) (define)

	if (owner == NULL || number_of_receivers <= 0) return LONG_MIN;

	time_t t0 = LONG_MAX, t1;
	for (int k = 0; k < number_of_receivers; k++) {
		void *rp = receiver_array[k];
		if ((t1 = ((Port*)rp)->Necessary_time_from())
			< t0) t0 = t1;
	}
	return t0;
}


time_t Sender_port::Necessary_time_to(void)
{	//		Sender_port::Necessary_time_to(void) (define)

	if (owner == NULL || number_of_receivers <= 0) return LONG_MAX;

	time_t t0 = LONG_MIN, t1;
	for (int k = 0; k < number_of_receivers; k++) {
		void *rp = receiver_array[k];
		if ((t1 = ((Port*)rp)->Necessary_time_to())
			> t0) t0 = t1;
	}
	return t0;
}


void Sender_port::Print_connection(FILE* fp_out, char* head)
{	//		Sender_port::Print_connection(FILE*,char*) (define)

	Oprint(fp_out, head);

	if (number_of_receivers <= 0)
		{ fprintf(fp_out, "%s\tNot connected.\n", head); return; }

	char* title = "Connected > ";
	int len = strlen(title) + 1;
	len += (head != NULL) ? strlen(head) : 0;

	char* tmp = new char[len];
	if (tmp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, YES); Oprint(); exit(5); }
			// <Sender_port::Print_connection>
	if (head != NULL) strcpy(tmp, head);
	else strcpy(tmp, "");
	strcat(tmp, title);

	for (int k = 0; k < number_of_receivers; k++)
		((Port*) receiver_array[k])->Oprint(fp_out, tmp);

	delete [] tmp;
}

void Sender_port::Set_comment_string(char* cmt)
{
    int len = strlen(cmt) + 1;
    comment_string = new char[len];
    if (comment_string != NULL) {
        strcpy(comment_string, cmt);
    } else {
        Eprint_memory(__FILE__,__LINE__,"char",len);
    }
}

char* Sender_port::Get_comment_string(void)
{
	if (comment_string == NULL) return NULL;
    int len = strlen(comment_string) + 1;
    char* cmt = new char[len];
    if (cmt != NULL) {
        strcpy(cmt, comment_string);
    } else {
        Eprint_memory(__FILE__,__LINE__,"char",len);
    }
	return cmt;
}

Sender_port::Sender_port(char* p_name, int p_num)
	:	Port(),
		buffer_list(NULL), receiver_array(NULL), number_of_receivers(-1)
{	//		Sender_port::Sender_port(char*,int) (define)

	class_name = "Sender_port";
	comment_string = NULL;
	Init(p_name, p_num);

	if ((buffer_list = new List) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Sender_port::Sender_port(char*,int)
			// For "buffer_list", to register 'receive_ports'.
}


Sender_port::Sender_port(void)
	:	Port(),
		buffer_list(NULL), receiver_array(NULL), number_of_receivers(-1)
{	//		Sender_port::Sender_port(void) (define)

	class_name = "Sender_port";
	comment_string = NULL;

	if ((buffer_list = new List) == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "List", YES); exit(5); }
			// Sender_port::Sender_port(void)
			// For "buffer_list", to register 'receive_ports'.
}


Sender_port::~Sender_port(void)
{	//		Sender_port::~Sender_port(void) (define)

	delete buffer_list;
	delete [] receiver_array;
	delete [] comment_string;
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Alterarions from Revision: 1.2
The implementations of the member functions Necessary_time_from and
Necessary_time_to were updateted.

Revision: 1.1 ѹ
delete ʸ delete [] 

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
