/*;  total.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl total.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:59:56 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/total.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) total.h -- total system

/* <japanese>
{\ {\setlength{\parskip}{4pt}% latex-mode
ΥإåեǤϡܷηϥǥб륯饹
\verb|Total_system| ޤ

ηϥǥ, ե, ͥåȥˤ, ܡ,
CRT Ϥʤ, ¿ʥǡϤбޤ ηϥǥ, 
¿ʥǡϤ˼,  {\tt Data\_pack} Υǡ
Ѵ, ߥ졼̤򥷥ߥ졼¹ԼԤ󶡤,
{\tt Data\_pack} ѤƤǡ򥷥ߥ졼¹ԼԤ˾
ǡѴޤ, ǡѴ˴ؤŪ, 
ü, üҤǹԤ, ηϥǥǤ, üҡüҤ
μ³ΤȤޤ.

ޤ, {\tt Data\_pack} Ѵϥǡ¾, ηϥǥ,
η˴ޤޤǤΥѥ᡼̤νͤ򥷥ߥ졼
¹ԼԤѰդǡե뤫ɤ߼뵡ǽƤޤ ޤ, 
ߥ졼¹ԼԤȤäˤ, ߥ졼ɸꤹ뵡
ǽƤޤ

ηϥǥ, ǡʬϤˤ깽, §Ȥƿ׻Ԥ鷺,
ʬϥǥƱͤι¤ƤޤܥƥǤ, ʬϥ
Ѿηϥǥޤ.

, ʬϥǥ뤬ϤФ륤ץåȥǡʬϳ
ΤФ, ηϤüҤѤƥץåȥǡ򼫤, 
Ǥޤޤ, Ǥ, Ϥ鳰˥ȥץåȤǡ
, ʬϥǥñ˳Ǥ, ηϥǥϽü
ҤѤ, 㤨, ϥե˵ϿȤäԤޤ

ܷηϥǥɽ饹 {\tt Total\_system} ǿɲä줿ǡ
, дؿϰʲ̤Ǥ

\begin{verbatim}
    ǡݥ
        terminal_time         : ǤΥɥ쥹
    дؿ
        Input_data            : ϤԤ.
        Output_data           : ؤνϤԤ.
    дؿκ
        Calculate_time_step   : ߥ졼ɸ򥷥ߥ졼
                                  ¹ԼԤäƷꤹ.
        Work                  : üҤѤ, ηϤФ
                                  ϤԤ. ޤ, Ǥ˷׻¹̿
                                  .
\end{verbatim}

}% end of latex-mode }
</japanese>
*/

#if !defined(total_h)
#define total_h

#include <stdio.h>
#include <time.h>		//; time_t , tm 
#include <limits.h>		//; LONG_MIN 

#include "common.h"		//; ץˤ붦
#include "sub.h"		//; 饹 Sub_system 


//; Definition of class Total_system

/*----------------------------------------------------------------------
CLASS
    Total_system

DESCRIPTION

    total system model

    <japanese>
    ηϥǥ, ե, ͥåȥˤ, ܡ
    , CRT Ϥʤ, ¿ʥǡϤбޤ ηϥ
    ǥ, ¿ʥǡϤ˼,  Data_pack
    ΥǡѴ, ߥ졼̤򥷥ߥ졼¹ԼԤ
    , Data_pack ѤƤǡ򥷥ߥ졼¹
    Ԥ˾ǡѴޤ, ǡѴ˴ؤŪ
    , ˺ü, üҤǹԤ, ηϥǥǤ, 
    üҡüҤμ³ΤȤޤ.

    ޤ, Data_pack Ѵϥǡ¾, ηϥǥ,
    ˴ޤޤǤΥѥ᡼̤νͤ򥷥ߥ졼
    ¹ԼԤѰդǡե뤫ɤ߼뵡ǽƤޤ ޤ,
    ߥ졼¹ԼԤȤäˤ, ߥ졼ɸ
    뵡ǽƤޤ

    ηϥǥ, ǡʬϤˤ깽, §Ȥƿ׻Ԥ
    ,ʬϥǥƱͤι¤ƤޤܥƥǤ, 
    ʬϥǥѾηϥǥޤ.

    , ʬϥǥ뤬ϤФ륤ץåȥǡʬϳ
    ΤФ, ηϤüҤѤƥץåȥǡ򼫤
    , Ǥޤޤ, Ǥ, Ϥ鳰˥
    ץåȤǡ, ʬϥǥñ˳Ǥ, 
    ϥǥϽüҤѤ, 㤨, ϥե˵ϿȤä
    Ԥޤ

    ܷηϥǥɽ饹 {\tt Total\_system} ǿɲä
    ǡ, дؿϰʲ̤Ǥ

    <pre>
    ǡݥ
        terminal_time         : ǤΥɥ쥹
    дؿ
        Input_data            : ϤԤ.
        Output_data           : ؤνϤԤ.
    дؿκ
        Calculate_time_step   : ߥ졼ɸ򥷥ߥ졼
                                  ¹ԼԤäƷꤹ.
        Work                  : üҤѤ, ηϤФ
                                  ϤԤ. ޤ, Ǥ˷׻¹̿
                                  .
    </pre>
    </japanese>

----------------------------------------------------------------------*/

class Total_system : public Sub_system {

public:
  //////////////////////////////////////////////////////////////////////
  // Definition of DataFileContent
  // <dl>
  // <dt>PARSET:  <dd>Parameter values are contained in the file.
  // <dt>INITIAL: <dd>Initial state values are contained in the file.
  // <dt>SDPDATA: <dd>Send port datapacks are contained in the file.
  // </dl>
  enum DataFileContent {PARSET, INITIAL, SDPDATA};

protected:
  //////////////////////////////////////////////////////////////////////
  // Data member.
  time_t terminal_time;

  //////////////////////////////////////////////////////////////////////
  // Data member. medium term target time.
  //
  // <japanese>
  // ɸ
  // </japanese>
  time_t mMediumTermTargetTime;

//  Simulation option

public:
  //////////////////////////////////////////////////////////////////////
  void Set_ohymos_option(void);

//;	1.	ͭü, ͭǥ֥, ͭʬϥ֥ȤϿ.
protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҤϿޤηϥǥΥץޤɬפ
  // ޤ
  // </japanese>
  virtual void Register_input_ports(void) = 0;

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ηϤ Register_send_ports ϡRegister_input_ports ¹Ԥ
  // ޤ
  // </japanese>
  void Register_send_ports(void) { Register_input_ports(); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҤϿޤηϥǥΥץޤɬפ
  // ޤ
  // </japanese>
  virtual void Register_output_ports(void) = 0;

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ηϤ Register_receive_ports ϡRegister_output_ports ¹Ԥ
  // 褦ޤ
  // </japanese>
  void Register_receive_ports(void) { Register_output_ports(); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ηϤιǤϿؿǤTotal_system Ѿơη
  // ץޤϡδؿɬפޤ
  // </japanese>
  virtual void Register_components(void) = 0;

protected:
  //////////////////////////////////////////////////////////////////////
  virtual void Connect_ports(void) = 0;
  //////////////////////////////////////////////////////////////////////
  virtual void Connect_components(void) = 0;

//;	3.	ηϥǥν.
protected:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡեΥեޥåȤγǧ
  // </japanese>
  Boolean Check_data_file(FILE* fp, char* f_name);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǡեϤơǤʸͿƥѥ᥿ꤹ
  // ͤꤹ롣content == PARSET ΤȤѥ᥿ꡤcontent
  // == INITIAL ΤȤ, content == SDPDATAΤȤüҤ˻Ĥ
  // Ƥǡκ
  // </japanese>
  void Deliver_data_string(char* f_file, DataFileContent content);

public:
  //////////////////////////////////////////////////////////////////////
  void Read_parameter_file(char* p_file);
  //////////////////////////////////////////////////////////////////////
  void Read_initial_state_file(char* i_file);
  //////////////////////////////////////////////////////////////////////
  void Read_send_port_file(char* s_file)
	{ Deliver_data_string(s_file, SDPDATA); }

//; ֤
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ե뤫 current_time ɤߤȤޤɬפʤ, ѾƤĤ
  // ηϥǥѹƤ
  // </japanese>
  virtual void Set_initial_state(FILE* fp);

// added by Yutaka ICHIKAWA (Sun Dec  1 20:09:42 1996)
public:
  //////////////////////////////////////////////////////////////////////
  virtual Element::OperationFlag Do_share_info(void);
  //; Element β۴ؿǤcocoon ϡη (:: ) ͤ
  //; 򤷤ʤΤǡ
  //; δؿϡhtml ե˼Ͽޤ

//;	3.	ηϥǥη׻.
  //////////////////////////////////////////////////////////////////////
  time_t Terminal_time(void) { return terminal_time; }

  //////////////////////////////////////////////////////////////////////
  time_t MediumTermTargetTime(void) { return mMediumTermTargetTime; }

  //////////////////////////////////////////////////////////////////////
  Boolean Input_data_time(time_t& input_from, time_t& input_to);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ۴ؿǤWork ƤФޤ٤ƤüҤ˥ǡ
  // ߹褦˻ᤷޤ
  // </japanese>
  void Input_data(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // Work ƤФޤ٤ƤνüҤ˥ǡ񤭽Ф褦˻
  // ޤ̤ϡե˽Ϥޤ
  // </japanese>
  void Output_data(void);

  //////////////////////////////////////////////////////////////////////
  Boolean Initial_output(void) { return YES; }
	// Usually there is no output from total_system.

// modified by Y.Ichikawa (Mon Nov 13 17:38:16 1995)
//; iterator_array ɲäбƽľ
	Boolean Initial_work(void);

  //////////////////////////////////////////////////////////////////////
  time_t Necessary_time_from(void) { return current_time; }
  //////////////////////////////////////////////////////////////////////
  time_t Necessary_time_to(void) { return terminal_time; }
	time_t Calculate_time_step(void);
	Boolean Calculate(void) { return YES; }

// modified by Y.Ichikawa (Mon Nov 13 20:07:59 1995)
//; iterator_array ɲäбƽľ
  //////////////////////////////////////////////////////////////////////
  Boolean Work(void);

//;  4.  ǽ֤¸ǽ

public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time 񤭹ߤޤɬפʤ, ѾƤĤηϥǥ
  // ѹƤ
  // </japanese>
  virtual void Save_terminal_state(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ǽ֤Υեؤ¸
  //
  // ե f_name 򿷵˥ץ󤷤, ηϤκǽ֤¸
  // ե f_name Ǥ¸ߤϾ񤭤ޤ
  // , дؿ Save_terminal_state, Sub_system::Terminal_state
  // ɤǤޤ
  // </japanese>
  void Write_terminal_state(char *f_name);

//; modified by Y.Ichikawa (Mon Nov 13 17:35:28 1995)
//; iterator_array ɲäбƽľ
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҤ˻ĤäƤǡ¸
  //
  // ե f_name 򿷵˥ץ󤷤, üҤ˻ĤäƤǡ
  // ե¸ޤե f_name Ǥ¸ߤϾ
  // ޤ
  //
  // , дؿ Element::Save_send_port_stock,
  // Sub_system::Save_send_port_stock ƤǤޤ
  // </japanese>
  void Write_send_port_stock(char *f_name);

//;	5.	ɽǽ.
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҾν
  // <pre>
  //    ARGUMENT:
  //        fp    եΥݥ. ǥե stderr.
  //        head  ϻΥإå. ǥեͣ.
  // </pre>
  // </japanese>
  void Print_inputs(FILE* fp = stderr, char* head = "    ")
		{ Print_objects(fp, head, "Inputs :",
						send_port_array, number_of_send_ports); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҾν
  // <pre>
  //    ARGUMENT:
  //        fp    եΥݥ. ǥե stderr.
  //        head  ϻΥإå. ǥեͣ.
  // </pre>
  // </japanese>
  void Print_outputs(FILE* fp = stderr, char* head = "    ")
		{ Print_objects(fp, head, "Outputs :",
						receive_port_array, number_of_receive_ports); }

//;	6. 󥹥ȥ饯, ǥȥ饯.
public:
//; added by Y.Ichikawa (Tue Nov 14 16:10:37 1995)
  //////////////////////////////////////////////////////////////////////
  Boolean Init(char* o_name = "total_system", int o_num = 0,
				 int num_of_itr = 0)
	{ return Sub_system::Init(o_name, o_num, 0, num_of_itr, NULL); }

//; modified by Y.Ichikawa
  //////////////////////////////////////////////////////////////////////
  Total_system(void);

  //////////////////////////////////////////////////////////////////////
  ~Total_system(void);

};

#endif	//	! total_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
